<!--
  Generated template for the SelectedtaskPage page.

  See http://ionicframework.com/docs/components/#navigation for more info on
  Ionic pages and navigation.
-->


<ion-content padding [class]="!activePage ? 'hide-page' : 'show-page'">
	<div class="close-modal-btn-container">
		<button ion-button (click)="modalDismiss()" class="close-modal-btn">
			<ion-icon name="close" class="close-modal-icon"></ion-icon><span class="close-modal-close-title">&nbsp;Close</span>
		</button>
	</div>

	<div class="task-content-outer-container">
		<div class="task-title-section-container">
			<p class="task-title">{{ task.taskName }}</p>
			<p class="task-section"><span class="task-section-title">In section: </span>{{ taskSection.taskSectionTitle }}</p>
			<ion-icon name="more" class="task-more-options" (click)="taskMoreOptions(isAdmin, priviledges)" *ngIf="isAdmin || priviledges"></ion-icon>
		</div>
		<div class="task-other-content-container">
			<div class="task-due-assigned-container">
				<div class="task-due-assigned-left-content">
					<div class="task-icon-container">
						<ion-icon name="time" class="task-time-icon"></ion-icon>
					</div>
					<div class="task-icon-container">
						<ion-icon name="people" class="task-people-icon"></ion-icon>
					</div>
					<div class="task-icon-container">
						<ion-icon name="pricetag" class="task-priority-icon"></ion-icon>
					</div>
				</div>
				<div class="task-due-assigned-right-content">
					<div class="task-due-assigned-inner-container">
						<div class="task-due-date-container">
							<span class="due-label" *ngIf="dueDate">Due </span>
							<p class="due-date-label-not-null" *ngIf="taskItems.dueDate" (click)="callDueDatePicker()">&nbsp;{{ taskItems.dueDate | date: 'd MMMM yyyy h:mm a' }}</p>
							<p class="due-date-label-null" *ngIf="!dueDate" (click)="callDueDatePicker()">Due date...</p>
							<a class="clear-due-btn" *ngIf="dueDate && isAdmin" (click)="clearDueDate()">Clear</a>
						</div>
						<div class="task-assigned-member-container" (click)="assignMemberToTask()">
							<p class="task-assigned-member-label" *ngIf="totalAssignedMem < 1">Members...</p>
							<p class="task-assigned-member-label" style="color: #000" *ngIf="totalAssignedMem > 0">Total Assigned Member: {{ totalAssignedMem }}</p>
						</div>
						<div class="task-priority-container" (click)="selectTaskPriority()">
							<p class="task-priority-label" *ngIf="!taskItems.priority">Priority...</p>
							<div class="task-priority-tag red" *ngIf="taskItems.priority == 'Urgent'"></div>
							<div class="task-priority-tag orange" *ngIf="taskItems.priority == 'High'"></div>
							<div class="task-priority-tag green" *ngIf="taskItems.priority == 'Normal'"></div>
							<div class="task-priority-tag grey" *ngIf="taskItems.priority == 'Low'"></div>
							<p class="task-priority" *ngIf="taskItems.priority">{{ taskItems.priority }}</p>
						</div>
					</div>
				</div>
			</div>
			<div class="task-subtask-outer-container">
				<div class="task-subtask-container">
					<div class="task-subtask-header-container" (click)="expandTaskList()">
						<ion-icon name="list-box" class="task-subtask-icon"></ion-icon>
						<p class="task-subtask-header">Sub-Task</p>
						<div class="task-subtask-arrow-down-container" >
							<ion-icon name="arrow-down" class="task-subtask-arrow-down-container"  *ngIf="!expandSubTask"></ion-icon>
							<ion-icon name="arrow-up" class="task-subtask-arrow-down-container" *ngIf="expandSubTask"></ion-icon>
						</div>
					</div>
					<div class="task-subtask-content-container" *ngIf="expandSubTask">
						<ion-list class="task-subtask-content-list" >
							<ion-item-sliding class="task-subtask-content-item-sliding" *ngFor="let subTasks of subTaskObjectList">
								<ion-item class="task-subtask-item" *ngIf="isAdmin || priviledges">
									<ion-label class="task-subtask-name">{{ subTasks.subTaskTitle }}</ion-label>
									<ion-checkbox (ionChange)="subTaskStatusChange(subTasks)" [checked]="subTasks.isDone" item-right color="secondary"></ion-checkbox>
								</ion-item>
								<ion-item class="task-subtask-item" *ngIf="!isAdmin && !priviledges">
									<ion-label class="task-subtask-name">{{ subTasks.subTaskTitle }}</ion-label>
									<ion-icon name="radio-button-off" item-right *ngIf="!subTasks.isDone"></ion-icon>
									<ion-icon name="checkmark-circle" item-right color="secondary" *ngIf="subTasks.isDone"></ion-icon>
								</ion-item>
								<ion-item-options slide="left" class="task-subtask-item-options" *ngIf="isAdmin">
									<button ion-button color="danger" (click)="deleteSelectedSubTask(subTasks)">
										<ion-icon name="trash"></ion-icon>
										Remove
									</button>
								</ion-item-options>
							</ion-item-sliding>
						</ion-list>
						<div class="task-subtask" *ngIf="isAdmin || priviledges">
							<ion-input placeholder="Add Sub-Task..." class="task-subtask-add-subtask-input" [(ngModel)]="subTask.subTaskTitle" (input)="countInputLength()"></ion-input>
							<ion-icon name="checkmark" class="add-subtask-add-btn" *ngIf="addSubTaskBtnVisible" (click)="addSubTask(subTask)"></ion-icon>
						</div>
						<div class="task-subtask no-priviledges" *ngIf="!isAdmin && !priviledges">
							<p class="no-subtask-found" *ngIf="totalOfSubTask == 0">There is no Sub-Task added yet.</p>
						</div>
					</div>
				</div>
			</div>
			<div class="task-polling-outer-container">
				<div class="task-polling-container">
					<div class="task-polling-header-container">
						<ion-icon name="stats" class="task-polling-icon"></ion-icon>
						<p class="task-polling-header">Poll</p>
						<ion-icon name="add" class="task-polling-add-icon" (click)="addPolling()" *ngIf="!addPollingPending && !pollIsCreated && isAdmin"></ion-icon>
						<ion-icon name="close" class="task-polling-add-icon" (click)="addPolling()" *ngIf="addPollingPending && !pollIsCreated && isAdmin"></ion-icon>
						<ion-icon name="trash" class="task-polling-add-icon" color="danger" (click)="removePolling()" *ngIf="isAdmin && pollIsCreated"></ion-icon>
					</div>
					<div class="task-polling-content-container">
						<div class="task-polling-poll-is-not-exist-container" *ngIf="!isAdmin && !pollIsCreated">
							<ion-item class="task-polling-poll-is-not-exist-item">
								<p class="task-polling-poll-is-not-exist-title">There is no poll created at the moment.</p>
							</ion-item>
						</div>
						<div class="task-polling-create-poll-container" *ngIf="addPollingPending && !pollIsCreated">
							<ion-list>
								<ion-item class="polling-type-item">
							    	<ion-label><span class="required-field">*</span>Polling Type</ion-label>
							    	<ion-select [(ngModel)]="poll.pollingType" (ionChange)="checkPollingType()">
							    		<ion-option value="multiple">Multiple Choices</ion-option>
							    		<ion-option value="single">Single Choices</ion-option>
							    	</ion-select>
								</ion-item>
								<ion-list class="multiple-choice-options-list" *ngIf="pollMultipleOptions">
									<ion-list-header class="multiple-choice-options-header"><span class="required-field">*</span>Multiple Choice Options:</ion-list-header>
									<ion-item class="multiple-choice-options-item">
										<ion-label class="multiple-choice-options-label-1" item-left>Allow </ion-label>
										<ion-input placeholder="No." class="multiple-choice-options-input" type="number" [(ngModel)]="numOfAllowedVote" item-left></ion-input>
										<ion-label class="multiple-choice-options-label-2" item-right>vote for each person.</ion-label>
									</ion-item>
								</ion-list>
								<ion-item class="polling-target-item">
							    	<ion-label><span class="required-field">*</span>Polling Target</ion-label>
							    	<ion-select [(ngModel)]="poll.pollingTarget">
							    		<ion-option value="group">Group Member</ion-option>
							    		<ion-option value="assigned">Assigned Member</ion-option>
							    	</ion-select>
								</ion-item>
								<div class="task-poll-due-date-outer-container">
									<div class="task-poll-due-date-container" (click)="callPollDatePicker()">
										<p>End Date/Time</p>
										<p *ngIf="!pollDueDate" class="task-poll-due-date-no-selection">End date...</p>
										<p *ngIf="pollDueDate" class="task-poll-due-date-selected">{{ formatPollDate(pollDueDate) | date: 'd MMMM yyyy h:mm a'}}</p>
									</div>
									<ion-icon name="trash" color="danger" *ngIf="taskPollDueDateIsSet" (click)="removePollDueDate()"></ion-icon>
								</div>
								<ion-item>
									<ion-label class="poll-option-header"><span class="required-field">*</span>Poll Options:</ion-label>
								</ion-item>
								<div *ngFor="let option of pollOptions; let i = index; let last = last; let first = first" class="poll-options-input-container">
									<div class="poll-options-input-item-not-last" *ngIf="!last">
										<ion-input placeholder="Options {{ i + 1 }}" class="poll-options-input" [(ngModel)]="pollOptions[i].option"></ion-input>
										<ion-icon name="trash" class="remove-option-btn-icon" (click)="removePollOptions(i)" *ngIf="pollOptionTotal > 2" color="danger" ></ion-icon>
									</div>
									<div class="poll-options-input-item-last" *ngIf=last>
										<ion-input placeholder="Options {{ i + 1 }}" class="poll-options-input" [(ngModel)]="pollOptions[i].option"></ion-input>
										<ion-icon name="trash" class="remove-option-btn-icon" (click)="removePollOptions(i)" *ngIf="pollOptionTotal > 2" color="danger"></ion-icon>
										<ion-icon name="add" class="add-option-btn-icon" (click)="addPollOptions()"></ion-icon>
									</div>
								</div>
								<ion-item class="poll-create-btn-icon-container">
									<button ion-button round color="secondary" class="poll-create-btn" outline (click)="createPoll(poll)" item-right>
										<ion-icon name="checkmark" class="poll-create-icon"></ion-icon>&nbsp;Create Poll
									</button>
								</ion-item>
							</ion-list>
						</div>
						<div class="task-polling-voting-poll-container" *ngIf="pollIsCreated && singleChoices">
							<ion-list class="single-vote-list" *ngIf="!voter.hasVoted && eligibleToVote && !pollExpired">
								<ion-list-header>
								    Poll Options: Single Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
								</ion-list-header>
								<ion-item *ngFor="let options of pollOptionsObjectList" class="poll-option-item">
									<ion-label>{{ options.option }}</ion-label>
									<ion-checkbox color="secondary" (click)="updateVote(options)" [checked]="options.key == voter.hasVoted" item-right></ion-checkbox>
								</ion-item>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="voter.hasVoted && eligibleToVote">
								<ion-list-header class="poll-result-header">
								    Poll Result: Single Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" *ngIf="!options.key == voter.hasVoted && eligibleToVote" class="poll-not-voted-icon"></ion-icon>
									<ion-icon name="checkmark-circle" color="secondary" *ngIf="options.key == voter.hasVoted && eligibleToVote" class="poll-voted-icon"></ion-icon>
								</div>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="!voter.hasVoted && eligibleToVote && pollExpired">
								<ion-list-header class="poll-result-header">
								    Poll Result: Single Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" class="poll-not-voted-icon"></ion-icon>
								</div>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="!eligibleToVote">
								<ion-list-header class="poll-result-header">
								    Poll Result: Single Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: 'd MMMM yyyy h:mm a' }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" *ngIf="!options.key == voter.hasVoted && eligibleToVote" class="poll-not-voted-icon"></ion-icon>
									<ion-icon name="checkmark-circle" color="secondary" *ngIf="options.key == voter.hasVoted && eligibleToVote" class="poll-voted-icon"></ion-icon>
								</div>
							</ion-list>
						</div>
						<div class="task-polling-voting-poll-container" *ngIf="pollIsCreated && multipleChoices">
							<ion-list class="single-vote-list" *ngIf="voterMultipleVotes < 1 && eligibleToVote && !pollExpired">
								<ion-list-header>
								    Poll Options: Multiple Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: "d MMMM yyyy h:mm a" }}</p>
								</ion-list-header>
								<ion-item *ngFor="let options of pollOptionsObjectList" class="poll-option-item">
									<ion-label>{{ options.option }}</ion-label>
									<ion-checkbox color="secondary" (ionChange)="updateMultipleVote(options)" [disabled]="!checking(options.key)" item-right></ion-checkbox>
								</ion-item>
								<ion-item>
									<button ion-button round class="vote-btn" color="secondary" (click)="submitMultipleVote()" [disabled]="storedVoteTotal < 1" item-right>
										Vote&nbsp;
										<ion-icon name="checkmark" class="vote-btn-icon"></ion-icon>
									</button>
								</ion-item>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="voterMultipleVotes.length > 0 && eligibleToVote">
								<ion-list-header class="poll-result-header">
								    Poll Result: Multiple Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: "d MMMM yyyy h:mm a" }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" *ngIf="!checkMultipleVote(options.key) && eligibleToVote" class="poll-not-voted-icon"></ion-icon>
									<ion-icon name="checkmark-circle" color="secondary" *ngIf="checkMultipleVote(options.key) && eligibleToVote" class="poll-voted-icon"></ion-icon>
								</div>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="voterMultipleVotes.length < 1 && eligibleToVote && pollExpired">
								<ion-list-header class="poll-result-header">
								    Poll Result: Multiple Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: "d MMMM yyyy h:mm a" }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" class="poll-not-voted-icon"></ion-icon>
								</div>
							</ion-list>
							<ion-list class="single-vote-list" *ngIf="!eligibleToVote">
								<ion-list-header class="poll-result-header">
								    Poll Result: Multiple Choices
								    <p class="polling-due-date" *ngIf="polls.pollingDueDate">End Time: {{ polls.pollingDueDate | date: "d MMMM yyyy h:mm a" }}</p>
								</ion-list-header>
								<div *ngFor="let options of pollOptionsObjectList" class="poll-options-item">
									<p class="poll-options-title">{{ options.option }}</p>
									<progress-bar [progress]="getPercentage(options.totalVote)" class="poll-progress-bar" [class]="eligibleToVote ? 'poll-progress-bar-eligible' : 'poll-progress-bar-not-eligible'"></progress-bar>
									<ion-icon name="radio-button-off" *ngIf="!options.key == voter.hasVoted && eligibleToVote" class="poll-not-voted-icon"></ion-icon>
									<ion-icon name="checkmark-circle" color="secondary" *ngIf="options.key == voter.hasVoted && eligibleToVote" class="poll-voted-icon"></ion-icon>
								</div>
							</ion-list>
						</div>
					</div>
				</div>
			</div>
			<div class="task-activity-log-outer-container">
				<div class="task-activity-log-container">
					<ion-list class="task-activity-log-list">
						<ion-list-header class="task-activity-log-header">
							<ion-icon name="paper" class="task-activity-log-header-icon" item-start></ion-icon>
							<ion-label class="task-activity-log-header-label">Activity Log</ion-label>
							<ion-icon name="options" class="task-activity-log-options-icon" item-end (click)="openFilterOptions()"></ion-icon>
						</ion-list-header>
						<div *ngFor="let activityLog of loggingActivity | reversethelistorder: filterOptions" class="task-activity-log-item-container">
							<ion-item class="task-activity-log-item" *ngIf="totalOfActivityLog > 0">
								<ion-icon name="stats" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'TaskPollLog'" item-start></ion-icon>
								<ion-icon name="move" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'MoveTaskLog'" item-start></ion-icon>
								<ion-icon name="time" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'TaskDueDateLog'" item-start></ion-icon>
								<ion-icon name="people" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'TaskAssignMemberLog'" item-start></ion-icon>
								<ion-icon name="pricetag" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'TaskPriorityLog'" item-start></ion-icon>
								<ion-icon name="create" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'TaskRenameLog'" item-start></ion-icon>
								<ion-icon name="list-box" class="task-activity-log-icon" *ngIf="activityLog.activityType == 'SubtaskLog'" item-start></ion-icon>
								<ion-label class="task-activity-log-label"><span class="task-activity-log-label-admin" *ngIf="activityLog.handlerIsAdmin">Admin</span>&nbsp;<span class="task-activity-log-label-handler">{{ activityLog.handler | gethandlername: userList }}</span>&nbsp;{{ activityLog.logActivity }}</ion-label>
								<ion-label class="task-activity-log-date" item-end>{{ activityLog.dateNTimeHandled | date: "d MMMM yyyy At h:mm a" }}</ion-label>
							</ion-item>
						</div>
						<div *ngIf="totalOfActivityLog < 1" class="task-activity-log-no-activity-outer-container">
							<div class="task-activity-log-no-activity-container">
								<p class="task-activity-log-no-activity-label">There is no activity found.</p>
							</div>
						</div>
					</ion-list>
				</div>
			</div>
		</div>
		<ion-item [hidden]="hideComponent">
			<ion-label>Move To Task Section:</ion-label>
			<ion-select #taskSectionList [(ngModel)]="selectedTaskSectionKey" (ionChange)="selectedTaskSect()">
				<div *ngFor="let taskSect of taskSectionList$ | async">
					<ion-option *ngIf="taskSect.key != selectedTaskSectKey" [value]="taskSect">{{ taskSect.taskSectionTitle }}</ion-option>
				</div>
			</ion-select>
		</ion-item>
		<ion-item [hidden]="hideComponent">
			<ion-label>Task Priority</ion-label>
			<ion-select #taskPriorityList [(ngModel)]="selectedTaskPriority" (ionChange)="setTaskPriority()">
				<ion-option value="Urgent">Urgent</ion-option>
				<ion-option value="High">High</ion-option>
				<ion-option value="Normal">Normal</ion-option>
				<ion-option value="Low">Low</ion-option>
				<ion-option value="none">None</ion-option>
			</ion-select>
		</ion-item>
		<ion-item [hidden]="hideComponent">
			<ion-label>Filter Type</ion-label>
			<ion-select #activityLogType [(ngModel)]="filterOptions.filterValue" (ionChange)="changeFilterType()">
				<ion-option value="TaskDueDateLog">Due Date Log</ion-option>
				<ion-option value="TaskAssignMemberLog">Assign Member Log</ion-option>
				<ion-option value="TaskPriorityLog">Priority Log</ion-option>
				<ion-option value="TaskPollLog">Poll Log</ion-option>
				<ion-option value="SubtaskLog">Sub-Task Log</ion-option>
				<ion-option value="MoveTaskLog">Task Moved Log</ion-option>
				<ion-option value="TaskRenameLog">Task Renamed Log</ion-option>
			</ion-select>
		</ion-item>
		<ion-datetime picker #dueDatePicker [hidden]="hideComponent" title="Task Due Date" displayFormat="D MMMM YYYY hh:mm A" [(ngModel)]="dueDate" placeholder="Due date..."(ionChange)="setDueDate()" [onlyValid]="{'between': {'initial': minDate, 'final': maxDate}, 'inclusive': true}"></ion-datetime>
		<ion-datetime picker #pollDueDatePicker [hidden]="hideComponent" title="Poll End Date/Time" displayFormat="D MMMM YYYY hh:mm A" pickerFormat="D-MMMM-YYYY HH:mm" [(ngModel)]="pollDueDate" placeholder="End date..." [onlyValid]="{'between': {'initial': minDate, 'final': maxDate}, 'inclusive': true}" class="task-poll-due-date" (ngModelChange)="checkPollDueDate()"></ion-datetime>
		<ion-item [hidden]="hideComponent">
			<ion-datetime picker #filterDateSelection text-center [(ngModel)]="filterOptions.filterValue" [max]="maxFilterDate" title="Filtered Date" [onlyValid]="{'before': maxFilterDate, 'inclusive': true}" date="{{hideComponent}}" (ionChange)="setFilterDate()" (click)="updateFilterMaxDate()"></ion-datetime>
		</ion-item>
	</div>

</ion-content>
